unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, DB, StdCtrls, ADODB, xmldom,
  XMLIntf, msxmldom, XMLDoc, XPMan, EncdDecd,
  GRDDelphi, Menus;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ADODataSet1: TADODataSet;
    XMLDocument1: TXMLDocument;
    XPManifest1: TXPManifest;
    ADOQuery1: TADOQuery;
    ADODataSet1ClientID: TIntegerField;
    ADODataSet1ClientName: TStringField;
    ADODataSet1ClientAddress: TStringField;
    ADODataSet1ClientTelNumber: TStringField;
    ADODataSet1ClientCity: TStringField;
    ADODataSet1ClientComments: TStringField;
    BtnCrypt: TButton;
    btnDecrypt: TButton;
    GroupBox1: TGroupBox;
    DBGrid2: TDBGrid;
    GroupBox2: TGroupBox;
    BtnEnCryptPurchase: TButton;
    BtnDeCryptPurchase: TButton;
    ADODataSet2: TADODataSet;
    DataSource2: TDataSource;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure BtnCryptClick(Sender: TObject);
    procedure btnDecryptClick(Sender: TObject);
    procedure BtnEnCryptPurchaseClick(Sender: TObject);
    procedure BtnDeCryptPurchaseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ConfigExists: Boolean; //       
  TelCodeArr : TStringList; //    
  ArrSource, ArrCrypt : Array[0..999] of String;

implementation

uses UnitBaseConnect;
{$R *.dfm}

  {       Guardant }
const
   CryptPU:      DWORD=$8566783;							{   }
   CryptRD:      DWORD=$7d49c84;							{   }
   InitVector:   LongInt = 327235620;          {    GSII64}
   InitVectorAES1: LongInt = 697394536;        {    AES ( 1)}
   InitVectorAES2: LongInt = 478236236;        {    AES ( 2)}

var
  BDPath, BDNew, BDAdmin, BDPassword : String; //     

  //     Guardant API
  nRet:  integer;			        {  .       }
  hGrd:HANDLE;                {   Guardant API }

  //     Guardant
  dwPublic:     DWORD;				{     }
  dwPrivRD:     DWORD;				{     }

  //           
  dwRemoteMode:         DWORD;					      { /  }
  dwFlags:              DWORD;							  {    }
  byProg:               Byte;								  {   }
  byVer:                Byte;									{  }
  dwID:                 DWORD;								{ ID  }
  wSN:                  Word;									{   }
  wMask:                Word;						      {   }
  wType:                Word;						      {   }
  dwModel:              DWORD;				        {   }
  dwInterface:          DWORD;			          {   : LPT, USB }

  szInitVectorGS2: String; //    GSII64
  szInitVectorAES:      string; {   AES}

  abyGrdAES_Context:    array[0..GrdAES_CONTEXT_SIZE] of Byte; //      
  
{----------------------------------------------------------------------------------------------}
{     Guardant API                                                       }

{ :    Guardant                                                             }
{	:                                                                              }
{	:                                                                             }
{--------------------------------------------------------------------------------------------- }
function ErrorHandling(hGrd:HANDLE;nRet:integer):integer;
var
    ErrorMsg:Array[1..5000] of Char;	{      }

begin
{        .     }
{ 1.         . }
{ 2.      ,   ,   .}

{   ,       }

  	  if( nRet <> GrdE_OK ) Then //   
	      begin
            //      Guardant     (      )
            GrdFormatMessage(hGrd,nRet,GrdLng_RUS,@ErrorMsg[1],5000,nil );
            MessageBox(0,@ErrorMsg, '',0);

           	if( hGrd <> nil )	Then //   ,      Guardant API
            begin
              //     
              GrdLogout(hGrd, 0);
              //  ,  
              GrdCloseHandle( hGrd );
            end;
            //   Guardant API
            GrdCleanup();
            ErrorHandling:=nRet;
            ExitProcess(0);exit;
	      end;
	    ErrorHandling:=nRet;
end;


// ------------------------------------------------------
//    .   .
// -------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  {-----------   Guardant API --------}

//  Guardant API
  nRet := GrdStartupEx(GrdFMR_Local, nil, nil);
  ErrorHandling(nil,nRet); {    }

//    Guardant API
  hGrd := GrdCreateHandle(nil, GrdCHM_MultiThread,  nil );
  ErrorHandling(hGrd,nRet);

  //      
  dwPublic:= GrdDC_DEMONVK-CryptPU;				{      }
  dwPrivRD:= GrdDC_DEMORDO-CryptRD;				{      }

  //      (   )
  nRet:= GrdSetAccessCodes(hGrd,   dwPublic + CryptPU,  dwPrivRD + CryptRD, 0, 0 );
  ErrorHandling(hGrd,nRet);


//    
    dwRemoteMode:= GrdFMR_Local;	{    }
    dwFlags:= GrdFM_NProg + GrdFM_Mask;     	{       }
    dwID:=   0;	                  { ID .   }
    byProg:= 5; 	                {     }
    wSN:=    0;	                  {  .      }
    byVer:=  0;                   { .     }
    wMask:=  77;                   {   }
    dwModel:= GrdFMM_ALL;         {   }
    dwInterface:= GrdFMI_ALL;     {    }
    nRet := GrdSetFindMode(hGrd,  dwRemoteMode, dwFlags, byProg, dwID, wSN, byVer, wMask, wType, dwModel, dwInterface );
    ErrorHandling(hGrd,nRet);

    //     (    GrdFindMode).
    //     Guardant API,    GrdCloseHandle()/GrdLogin()    
    nRet:= GrdLogin(hGrd,  $0FFFFFFFF, GrdLM_PerStation );
    ErrorHandling(hGrd,nRet);
  {-----------   Guardant API --------}


 ConfigExists := True;
//    
 if Not(FileExists('config.xml')) then
  Begin
   ShowMessage('   ');
   ConfigExists := False;
  End;

 if ConfigExists then //    
 Begin
  //      
   XMLDocument1.LoadFromFile('config.xml');
   XMLDocument1.Active := true;
   BDPath := DecodeString(XMLDocument1.DocumentElement.ChildNodes['DBPath'].Text);
   BDAdmin := XMLDocument1.DocumentElement.ChildNodes['DBAdmin'].Text;
   BDPassword := XMLDocument1.DocumentElement.ChildNodes['DBPassword'].Text;

  {-----------   Guardant API --------}

	  {       GSII64 }

	  szInitVectorGS2:=IntToHex(InitVector,8);	{     GSII64, 8  }
    nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   01,                    {    }
                   Length(BDPath),        {     }
                   @BDPath[1],            {      }
                   GrdAM_OFB + GrdAM_Decode,		{    OFB }
					         @szInitVectorGS2[1],					{ 64-   }
					         nil,									{   }
				           nil );							 	{   }
    ErrorHandling(hGrd,nRet);

 {-----------   Guardant API --------}

  //    
 if (BDPath[2] <> ':') then
   BDPath:= GetCurrentDir + '\' + BDPath;

 if Not(FileExists(BDPath)) then
  Begin
   ShowMessage('    ');
   ConfigExists := False;
  End;

//     ADO
 BDNew := 'Provider=Microsoft.Jet.OLEDB.4.0;' +
          'Data Source=' + BDPath + ';' +
          'User ID='+BDAdmin+'; Password='+BDPassword+';'+
          'Mode=Share Deny None;Extended Properties="";' +
          'Jet OLEDB:Engine Type=5;';

    if ConfigExists then
    Begin
      ADOConnection1.ConnectionString := BDNew;
      ADOConnection1.Open;
      if Not(ADOConnection1.Connected) then ConfigExists := False;
    End;
  End;

end;

// ------------------------------------------------------
//   .   .
// -------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ADOConnection1.Connected then //     ,  
  Begin
    ADODataSet1.Close;
    ADOConnection1.Close;
  end;

  {-----------   Guardant API --------}
	if( hGrd <> nil )	Then //   ,      Guardant API
    begin
      //     
      nRet := GrdLogout(hGrd, 0);
      //  ,  
      nRet:= GrdCloseHandle( hGrd );
    end;
  //   Guardant API
  nRet:= GrdCleanup();

  {-----------   Guardant API --------}
end;


//    " "
procedure TForm1.FormShow(Sender: TObject);
Var
  confignode, xnode: ixmlnode;
  i : integer;
begin
  if Not(ConfigExists) then
  Begin
    //      
    FormBaseConnect.OpenDialog1.InitialDir := GetCurrentDir;
    FormBaseConnect.ShowModal;

    if Not(ConfigExists) then //      
    Begin
      Form1.Close; Exit;
    End;

   //
   BDPath := FormBaseConnect.EditPath.Text;

  {-----------   Guardant API --------}

	  {       GSII64 }

	  szInitVectorGS2:=IntToHex(InitVector,8);	{     GSII64, 8  }
    nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   01,                    {    }
                   Length(BDPath),        {     }
                   @BDPath[1],            {      }
                   GrdAM_OFB + GrdAM_Encode,		{    OFB }
					         @szInitVectorGS2[1],					{ 64-   }
					         nil,									{   }
				           nil );							 	{   }
    ErrorHandling(hGrd,nRet);

 {-----------   Guardant API --------}


    //   
      XMLDocument1.XML.Clear;
      XMLDocument1.Active := true;
      confignode := XMLDocument1.AddChild('config');
      xnode := confignode.AddChild('DBPath');
      xnode.Text :=  EncodeString(BDPath);   //        ,
                                             //    base64
      xnode :=  confignode.AddChild('DBAdmin');
      xnode.Text :=  FormBaseConnect.EditUsername.Text;
      xnode := confignode.AddChild('DBPassword');
      xnode.Text :=  FormBaseConnect.EditPassword.Text;
      XMLDocument1.XML.Text := FormatXMLData(XMLDocument1.XML.Text); //  XML
      XMLDocument1.XML.SaveToFile('config.xml');
  End;

  if ConfigExists then
    Begin
      //     
      ADODataSet1.Connection := ADOConnection1;
      ADODataSet1.CommandText := 'select * from ClientsList ORDER BY `ClientName`';
      ADODataSet1.Open;


      //   
      DBGrid1.fields[0].DisplayLabel := 'ID';
      DBGrid1.fields[1].DisplayLabel := '';
      DBGrid1.fields[2].DisplayLabel := '';
      DBGrid1.fields[3].DisplayLabel := '';
      DBGrid1.fields[4].DisplayLabel := '';
      DBGrid1.fields[5].DisplayLabel := '';

      //    
      DBGrid1.Fields[0].DisplayWidth := 5;
      For i:=1 to DBGrid1.FieldCount-1 do DBGrid1.Fields[i].DisplayWidth := 20;


      //     
      ADODataSet2.Connection := ADOConnection1;
      ADODataSet2.CommandText := 'select * from Shopping ORDER BY ID';
      ADODataSet2.Open;


      DBGrid2.fields[0].DisplayLabel := 'ID';
      DBGrid2.fields[1].DisplayLabel := 'ID ';
      DBGrid2.fields[2].DisplayLabel := '';
      DBGrid2.fields[3].DisplayLabel := '';

    End;

end;




procedure TForm1.BtnCryptClick(Sender: TObject);
var
 CommCrypt, CommCrypt64: String;
 ClientID : DWORD;
begin
   ADODataSet1.First;  //    
   while Not(ADODataSet1.Eof) do
   begin
      ADODataSet1.Edit; //   
      //  
      ClientID := StrToInt(ADODataSet1.FieldByName('ClientID').Text);
      CommCrypt := ADODataSet1.FieldByName('ClientComments').Text;
      //   
      ClientID := ClientID xor 769390234;

      szInitVectorGS2:=IntToHex(ClientID,8);	{     GSII64, 8  }
      //     GSII64
      nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   04,                    {    }
                   Length(CommCrypt),        {     }
                   @CommCrypt[1],            {      }
                   GrdAM_OFB + GrdAM_Encode,		{    OFB }
					         @szInitVectorGS2[1],					{ 64-   }
					         nil,									{   }
				           nil );							 	{   }
      ErrorHandling(hGrd,nRet);
      //   Base64
      CommCrypt64 := EncodeString(CommCrypt);
      ADODataSet1.FieldByName('ClientComments').Text := CommCrypt64;
      ADODataSet1.UpdateRecord; // 
      ADODataSet1.Next;     //  
    end;
end;

procedure TForm1.btnDecryptClick(Sender: TObject);
var
 CommDeCrypt: String;
 ClientID : DWORD;
begin
   ADODataSet1.First; //    
   while Not(ADODataSet1.Eof) do
   begin
      ADODataSet1.Edit;
      //  
      ClientID := StrToInt(ADODataSet1.FieldByName('ClientID').Text);
      ClientID := ClientID xor 769390234;
      CommDeCrypt := DecodeString(ADODataSet1.FieldByName('ClientComments').Text);

      szInitVectorGS2:=IntToHex(ClientID,8);	{     GSII64, 8  }
      //     GSII64
      nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   04,                    {    }
                   Length(CommDeCrypt),        {     }
                   @CommDeCrypt[1],            {      }
                   GrdAM_OFB + GrdAM_Decode,		{    OFB }
					         @szInitVectorGS2[1],					{ 64-   }
					         nil,									{   }
				           nil );							 	{   }
      ErrorHandling(hGrd,nRet);
      ADODataSet1.FieldByName('ClientComments').Text := CommDeCrypt;
      ADODataSet1.UpdateRecord; // 
      ADODataSet1.Next;  //  
    end;
end;

{ ----------    -------------}
procedure TForm1.BtnEnCryptPurchaseClick(Sender: TObject);
var
 ClientID : DWORD;
 ClientName : String;
 CryptKeyAES : String; //        AES
 PurchaseName : String;
begin
   szInitVectorAES:=IntToHex(InitVectorAES1,8)+IntToHex(InitVectorAES2,8);	{     AES128, 16  }

   ADODataSet1.First;
   while Not(ADODataSet1.Eof) do
   begin
      //  ID   
      ClientID := StrToInt(ADODataSet1.FieldByName('ClientID').Text);
      ClientName := ADODataSet1.FieldByName('ClientName').Text;
      //      ID   
      CryptKeyAES :=  IntToStr(ClientID) + ClientName;
      //    ,    ID
      while (Length(CryptKeyAES)<33) do CryptKeyAES := CryptKeyAES + IntToStr(ClientID);
      //   32 
      CryptKeyAES := Copy(CryptKeyAES,1,32);

      {       GSII64}
      nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   04,                    {    }
                   Length(CryptKeyAES),        {     }
                   @CryptKeyAES[1],            {      }
                   GrdAM_ECB + GrdAM_Encode,		{    ECB }
					         nil,					        {   ECB   }
					         nil,									{   }
				           nil );							 	{   }
      ErrorHandling(hGrd,nRet);

      //      
      ADODataset2.Close;
      ADODataSet2.CommandText := 'select * from Shopping WHERE ClientID='+IntToStr(ClientID);
      ADODataSet2.Open;
      ADODataSet2.First;

      while (Not(ADODataSet2.Eof)) do
      Begin
        PurchaseName := ADODataSet2.FieldByName('PurchaseName').Text; //     

        {   -  AES256 }
     	  nRet:= GrdCrypt(hGrd,				    {   Guardant }
					          GrdSC_AES256,			  {  -  AES256}
					          Length(PurchaseName),						{   }
                    @PurchaseName[1],			{   / }
                    GrdAM_Encrypt + GrdAM_CFB + GrdSC_All, 	{    CFB,   }
                    @szInitVectorAES[1],			{   }
                    @CryptKeyAES[1],								{    / }
                    @abyGrdAES_Context[0] );			{      }
        ErrorHandling(hGrd,nRet);

        ADODataSet2.Edit; //  
        //   ,       base64, ..          
        ADODataSet2.FieldByName('PurchaseName').Text := EncodeString(PurchaseName);
        ADODataSet2.UpdateRecord;
        ADODataSet2.Next;
      end;

      ADODataSet1.Next;
    end;
      ADODataSet2.Close;
      ADODataSet2.CommandText := 'select * from Shopping ORDER BY ID';
      ADODataSet2.Open;
end;

{ ----------    -------------}
procedure TForm1.BtnDeCryptPurchaseClick(Sender: TObject);
var
 ClientID : DWORD;
 ClientName : String;
 CryptKeyAES : String; //        AES
 PurchaseName : String;
begin
   szInitVectorAES:=IntToHex(InitVectorAES1,8)+IntToHex(InitVectorAES2,8);	{     AES128, 16  }

   ADODataSet1.First;
   while Not(ADODataSet1.Eof) do
   begin
      
      //  ID   
      ClientID := StrToInt(ADODataSet1.FieldByName('ClientID').Text);
      ClientName := ADODataSet1.FieldByName('ClientName').Text;
      //      ID   
      CryptKeyAES :=  IntToStr(ClientID) + ClientName;
      //       32 ,    ID
      while (Length(CryptKeyAES)<33) do CryptKeyAES := CryptKeyAES + IntToStr(ClientID);
      //      32 
      CryptKeyAES := Copy(CryptKeyAES,1,32);

      {       GSII64}
      nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   04,                    {    }
                   Length(CryptKeyAES),        {     }
                   @CryptKeyAES[1],            {      }
                   GrdAM_ECB + GrdAM_Encode,		{    ECB }
					         nil,					        {   ECB   }
					         nil,									{   }
				           nil );							 	{   }
      ErrorHandling(hGrd,nRet);

      //      
      ADODataset2.Close;
      ADODataSet2.CommandText := 'select * from Shopping WHERE ClientID='+IntToStr(ClientID);
      ADODataSet2.Open;
      ADODataSet2.First;

      while (Not(ADODataSet2.Eof)) do
      Begin
        PurchaseName := ADODataSet2.FieldByName('PurchaseName').Text; //     
        PurchaseName := DecodeString(PurchaseName); //   Base64
        {   -  AES256 }
     	  nRet:= GrdCrypt(hGrd,				    {   Guardant }
					          GrdSC_AES256,			  {  -  AES256}
					          Length(PurchaseName),						{   }
                    @PurchaseName[1],			{   / }
                    GrdAM_Decrypt + GrdAM_CFB + GrdSC_All, 	{    CFB,   }
                    @szInitVectorAES[1],			{   }
                    @CryptKeyAES[1],								{    / }
                    @abyGrdAES_Context[0] );			{      }
        ErrorHandling(hGrd,nRet);

        ADODataSet2.Edit; //  
        //      
        ADODataSet2.FieldByName('PurchaseName').Text := PurchaseName;
        ADODataSet2.UpdateRecord;
        ADODataSet2.Next;
      end;

      ADODataSet1.Next;
    end;
      ADODataSet2.Close;
      ADODataSet2.CommandText := 'select * from Shopping ORDER BY ID';
      ADODataSet2.Open;

end;

end.



