unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, DB, StdCtrls, ADODB, xmldom,
  XMLIntf, msxmldom, XMLDoc, XPMan, EncdDecd, Wcrypt2,
  GRDDelphi, UnitAddClient, Menus;

type
  TForm1 = class(TForm)
    ADOConnection1: TADOConnection;
    GroupBox1: TGroupBox;
    BtnFindName: TButton;
    EditFindName: TEdit;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    ADOTable1: TADOTable;
    ADODataSet1: TADODataSet;
    GroupBox2: TGroupBox;
    EditFindTel: TEdit;
    BtnFindTel: TButton;
    GroupBox3: TGroupBox;
    EditFilterAddress: TEdit;
    BtnFilterEnabled: TButton;
    BtnFilterDisabled: TButton;
    EditFilterName: TEdit;
    LabelFilterName: TLabel;
    LabelFilterAddress: TLabel;
    EditFilterTel: TEdit;
    LabelFilterTel: TLabel;
    XMLDocument1: TXMLDocument;
    XPManifest1: TXPManifest;
    ADOQuery1: TADOQuery;
    GroupBox4: TGroupBox;
    BtnPurchaseReport: TButton;
    PopupMenuReport: TPopupMenu;
    N1: TMenuItem; 
    ADODataSet1Comments: TStringField;
    ADODataSet1ClientID: TIntegerField;
    ADODataSet1ClientName: TStringField;
    ADODataSet1ClientAddress: TStringField;
    ADODataSet1ClientTelNumber: TStringField;
    ADODataSet1ClientCity: TStringField;
    ADODataSet1ClientComments: TStringField;    
    BtnPurchaseAdd: TButton;
    N2: TMenuItem;    
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtnFindNameClick(Sender: TObject);
    procedure BtnFindTelClick(Sender: TObject);
    procedure BtnFilterEnabledClick(Sender: TObject);
    procedure BtnFilterDisabledClick(Sender: TObject);
    procedure UpdateFilter;
    procedure EditFilterNameChange(Sender: TObject);
    procedure EditFilterAddressChange(Sender: TObject);
    procedure EditFilterTelChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DBNavigator1BeforeAction(Sender: TObject;
      Button: TNavigateBtn);
    procedure BtnPurchaseReportClick(Sender: TObject);
    procedure ADODataSet1CalcFields(DataSet: TDataSet);
    procedure BtnPurchaseAddClick(Sender: TObject);
    procedure ADODataSet1NewRecord(DataSet: TDataSet);
    procedure ADODataSet1AfterOpen(DataSet: TDataSet);
    
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  {  ,      }
  TProtectThread = class(TThread)
    private
      { Private declarations }
    protected
      procedure Execute; override;
    end;

var
  Form1: TForm1;
  ConfigExists: Boolean; //       
  TelCodeArr : TStringList; //    
  ArrSource, ArrCrypt : Array[0..999] of String;
  ProtectThread: TProtectThread;  //   

implementation

uses UnitBaseConnect, UnitTelCode, UnitPurchaseReport, UnitAddPurchase;
{$R *.dfm}

  {       Guardant }
const
   CryptPU:      DWORD=$8566783;							{   }
   CryptRD:      DWORD=$7d49c84;							{   }
   InitVector:   LongInt = 327235620;          {    GSII64}
   InitVectorAES1: LongInt = 697394536;        {    AES ( 1)}
   InitVectorAES2: LongInt = 478236236;        {    AES ( 2)}

var
  BDPath, BDNew, BDAdmin, BDPassword : String; //     

  //       
  ClientID : LongInt;
  ClientName : String;

  //     Microsoft CryptoAPI
  hProv: HCRYPTPROV;


  //     Guardant API
  nRet:  integer;			        {  .       }
  hGrd, hGrdThread :HANDLE;                {   Guardant API }

  //     Guardant
  dwPublic:     DWORD;				{     }
  dwPrivRD:     DWORD;				{     }

  //  ,      
  GrdFindInfo1, GrdFindInfo2 : TGrdFindInfo;

  //           
  dwRemoteMode:         DWORD;					      { /  }
  dwFlags:              DWORD;							  {    }
  byProg:               Byte;								  {   }
  byVer:                Byte;									{  }
  dwID:                 DWORD;								{ ID  }
  wSN:                  Word;									{   }
  wMask:                Word;						      {   }
  wType:                Word;						      {   }
  dwModel:              DWORD;				        {   }
  dwInterface:          DWORD;			          {   : LPT, USB }

  //   
  donglefindcount:      integer;

//    
  ReadData: array[0..52] of Char;

  szInitVectorGS2: String; //    GSII64
  szInitVectorAES:      string; {   AES}

  abyGrdAES_Context:    array[0..GrdAES_CONTEXT_SIZE] of Byte; //      

  DataForSign: array[1..20] of Byte;	{     }
  ECCSign    : array[1..40] of byte;  {     }
  CRCSign : DWORD; {  ,        }

  GrdRand : Array[1..8] of Byte; { }
(*
  ECCPublicKey : array[1..40] of byte = {       ECC160}
  ($6B, $0C, $CB, $ED, $30, $C7, $8B, $04, 	$36, $63,
  $99, $66, $02, $A9, $16, $3A, $FB, $52, $4B, $7A,
	$85, $A1, $F3, $F3, $88, $F7, $2B, $3D, $DD, $E1,
  $8D, $98, $40, $D9, $69, $66, $35, $F8, $8E, $64);
*)
  ECCPublicKey : array[1..40] of byte = {       ECC160}
  ($59, $66, $4C, $77, $E1, $20, $17, $4A, $6B, $BF,
  $DC, $15, $68, $C2, $CF, $1C, $5A, $E4, $5B, $53,
  $2A, $92, $4F, $04, $E9, $74, $AE, $1D, $0F, $84,
  $A1, $87, $9E, $90, $25, $99, $11, $B3, $CB, $DC);

{----------------------------------------------------------------------------------------------}
{     Guardant API                                                       }

{ :    Guardant                                                             }
{	:                                                                              }
{	:                                                                             }
{--------------------------------------------------------------------------------------------- }
function ErrorHandling(hGrd:HANDLE;nRet:integer):integer;
var
    ErrorMsg:Array[1..5000] of Char;	{      }

begin
{        .     }
{ 1.         . }
{ 2.      ,   ,   .}

{   ,       }

  	  if( nRet <> GrdE_OK ) Then //   
	      begin
            //      Guardant     (      )
            GrdFormatMessage(hGrd,nRet,GrdLng_RUS,@ErrorMsg[1],5000,nil );
            MessageBox(0,@ErrorMsg, '',0);

           	if( hGrd <> nil )	Then //   ,      Guardant API
            begin
              //     
              GrdLogout(hGrd, 0);
              //  ,  
              GrdCloseHandle( hGrd );
            end;
            //   Guardant API
            GrdCleanup();
            ErrorHandling:=nRet;
            Form1.Close; exit;
	      end;
	    ErrorHandling:=nRet;
end;


// ------------------------------------------------------
//    .   .
// -------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
   i : Integer; //  
begin
  {-----------   Guardant API --------}

//  Guardant API
  nRet := GrdStartupEx(GrdFMR_Local, nil, nil);
  ErrorHandling(nil,nRet); {    }

//    Guardant API
  hGrd := GrdCreateHandle(nil, GrdCHM_MultiThread,  nil );
  ErrorHandling(hGrd,nRet);

  //      
  dwPublic:= GrdDC_DEMONVK-CryptPU;				{      }
  dwPrivRD:= GrdDC_DEMORDO-CryptRD;				{      }

  //      (   )
  nRet:= GrdSetAccessCodes(hGrd,   dwPublic + CryptPU,  dwPrivRD + CryptRD, 0, 0 );
  ErrorHandling(hGrd,nRet);

  {$IFDEF Debug}
  //          ID
  nRet:= GrdFind(hGrd,  GrdF_First, @dwID, @GrdFindInfo1);
  //    
//  if ( nRet = GrdE_OK )
  donglefindcount := 0;

  while( nRet = GrdE_OK ) do
	    begin
        ShowMessage ('ID = '+IntToStr(dwID));
        inc(donglefindcount);
        //   
		    nRet:= GrdFind( hGrd, GrdF_Next , @dwID, @GrdFindInfo2 );
	    end;

    if( nRet = GrdE_AllDonglesFound )	then{      }
        ShowMessage ('  ')
	  else
		  ErrorHandling(hGrd,nRet);

     if (donglefindcount=0) then //     
     begin
         {    }
         ShowMessage('   .');
         Form1.Close; exit;
     end
      else //     1  
     begin
      //          GrdFindInfo1
      ShowMessage(
        '     : '   + chr(10)+chr(13)+
        'ID  = ' + IntToStr(GrdFindInfo1.dwID) + chr(10)+chr(13)+
        '  = 0x'+ IntToHex(GrdFindInfo1.dwPublicCode,8) + chr(10)+chr(13)+
        '  = ' + IntToStr(GrdFindInfo1.byHrwVersion)  + chr(10)+chr(13)+
        '   () = ' + IntToStr(GrdFindInfo1.byMaxNetRes) + chr(10)+chr(13)+
        '  = ' + IntToHex(GrdFindInfo1.wType,4) + chr(10)+chr(13)+
        '  = ' + IntToStr(GrdFindInfo1.byNProg) + chr(10)+chr(13)+
        '  = ' + IntToStr(GrdFindInfo1.byVer) + chr(10)+chr(13)+
        '  = ' + IntToStr(GrdFindInfo1.wSN) + chr(10)+chr(13)+
        '   = ' + IntToStr( GrdFindInfo1.wMask)+ chr(10)+chr(13)+
        '  = ' + IntToStr( GrdFindInfo1.wGP)+ chr(10)+chr(13)+
        '   =  ' + IntToStr( GrdFindInfo1.wRealNetRes)+ chr(10)+chr(13)+
        ' = ' + IntToStr( GrdFindInfo1.dwIndex)
    );
    end;
    {$ENDIF}  


//    
    dwRemoteMode:= GrdFMR_Local;	{    }
    dwFlags:= GrdFM_NProg + GrdFM_Mask;     	{       }
    dwID:=   0;	                  { ID .   }
    byProg:= 5; 	                {     }
    wSN:=    0;	                  {  .      }
    byVer:=  0;                   { .     }
    wMask:=  77;                   {   }
    dwModel:= GrdFMM_ALL;         {   }
    dwInterface:= GrdFMI_ALL;     {    }
    nRet := GrdSetFindMode(hGrd,  dwRemoteMode, dwFlags, byProg, dwID, wSN, byVer, wMask, wType, dwModel, dwInterface );
    ErrorHandling(hGrd,nRet);

    //     (    GrdSetFindMode ).
    //     Guardant API,    GrdCloseHandle()/GrdLogin()    
    nRet:= GrdLogin(hGrd,  $0FFFFFFFF, GrdLM_PerStation );
    ErrorHandling(hGrd,nRet);

   {---         ----------}

  //    Guardant API
  hGrdThread := GrdCreateHandle(nil, GrdCHM_MultiThread,  nil );
  ErrorHandling(hGrdThread,nRet);

  //      (   )
  nRet:= GrdSetAccessCodes(hGrdThread,   dwPublic + CryptPU,  dwPrivRD + CryptRD, 0, 0 );
  ErrorHandling(hGrdThread,nRet);

  //    
  nRet := GrdSetFindMode(hGrdThread,  dwRemoteMode, dwFlags, byProg, dwID, wSN, byVer, wMask, wType, dwModel, dwInterface );
  ErrorHandling(hGrdThread,nRet);

  //     (    GrdSetFindMode).
  //     Guardant API,    GrdCloseHandle()/GrdLogin()    
  nRet:= GrdLogin(hGrdThread,  $0FFFFFFFF, GrdLM_PerStation );
  ErrorHandling(hGrdThread,nRet);

  {-----------   Guardant API --------}

 {  Microsoft CryptoAPI }
 CryptAcquireContext(@hProv, nil, nil, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT);


 ConfigExists := True;
//    
 if Not(FileExists('config.xml')) then
  Begin
   ShowMessage('   ');
   ConfigExists := False;
  End;

 if ConfigExists then //    
 Begin
  //      
   XMLDocument1.LoadFromFile('config.xml');
   XMLDocument1.Active := true;
   BDPath := DecodeString(XMLDocument1.DocumentElement.ChildNodes['DBPath'].Text);
   BDAdmin := XMLDocument1.DocumentElement.ChildNodes['DBAdmin'].Text;
   BDPassword := XMLDocument1.DocumentElement.ChildNodes['DBPassword'].Text;

  {-----------   Guardant API --------}

	  {       GSII64 }

	  szInitVectorGS2:=IntToHex(InitVector,8);	{     GSII64, 8  }
    nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   01,                    {    }
                   Length(BDPath),        {     }
                   @BDPath[1],            {      }
                   GrdAM_OFB + GrdAM_Decode,		{    OFB }
					         @szInitVectorGS2[1],					{ 64-   }
					         nil,									{   }
				           nil );							 	{   }
    ErrorHandling(hGrd,nRet);

 {-----------   Guardant API --------}

  //    
  TelCodeArr := TStringList.Create;
  FillTelCode; //  

  //    
 if (BDPath[2] <> ':') then
   BDPath:= GetCurrentDir + '\' + BDPath;

 if Not(FileExists(BDPath)) then
  Begin
   ShowMessage('    ');
   ConfigExists := False;
  End;

//     ADO
 BDNew := 'Provider=Microsoft.Jet.OLEDB.4.0;' +
          'Data Source=' + BDPath + ';' +
          'User ID='+BDAdmin+'; Password='+BDPassword+';'+
          'Mode=Share Deny None;Extended Properties="";' +
          'Jet OLEDB:Engine Type=5;';

    if ConfigExists then
    Begin
      ADOConnection1.ConnectionString := BDNew;
      ADOConnection1.Open;
      if Not(ADOConnection1.Connected) then ConfigExists := False;
    End;
  End;

  //     
  for i := 1 To 20 Do DataForSign[i] := 0;
  for i := 1 To 40 Do ECCSign[i] := 0;


  randomize; //    

  {     }
  ProtectThread:=TProtectThread.Create(true);
  ProtectThread.FreeOnTerminate:=true;
  ProtectThread.Priority:=tpLower; //  
  ProtectThread.Resume; //  

end;

// ------------------------------------------------------
//   .   .
// -------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   //    Microsoft CryptoAPI
   CryptReleaseContext(hProv, 0);
   TelCodeArr.Free; //    

  if ADOConnection1.Connected then //     ,  
  Begin
    ADODataSet1.Close;
    ADOConnection1.Close;
  end;

  {-----------   Guardant API --------}
	if( hGrd <> nil )	Then //   ,      Guardant API
    begin
      //     
      nRet := GrdLogout(hGrd, 0);
      //  ,  
      nRet:= GrdCloseHandle( hGrd );
    end;

  //      
	if( hGrdThread <> nil )	Then //   ,      Guardant API
    begin
      //     
      nRet := GrdLogout(hGrdThread, 0);
      //  ,  
      nRet:= GrdCloseHandle( hGrdThread );
    end;

  //   Guardant API
  nRet:= GrdCleanup();
  {-----------   Guardant API --------}
  ExitProcess(0);
end;

procedure TForm1.BtnFindNameClick(Sender: TObject);

begin
//   ,        ,   
  if (Length(trim(EditFindName.Text))=0) then exit;



  {-----------   Guardant API --------}
  {$IFDEF Debug}
    {        }
    nRet:= GrdRead(hGrd,             { }
                   24,              {      }
                   52,               {    }
                   @ReadData[0],     {  ,     }
                   nil);             {}
    ErrorHandling(hGrd,nRet);        { }

    {    SAM}
	  nRet:= GrdSetWorkMode(hGrd,       { }
                          GrdWM_SAM,  {  }
                          GrdWMFM_DriverAuto);  {   }
    ErrorHandling(hGrd,nRet);

    {   ID }
    nRet:= GrdRead(hGrd,             { }
                   GrdSAM_dwID,      {   }
                   4,   {   }
                   @ReadData[0],          {  }
                   nil);             {}
    ErrorHandling(hGrd,nRet);        { }

   dwID := ord(ReadData[0])+ ord(ReadData[1])*256 + ord(ReadData[2])*65536 + ord(ReadData[3])*16777216;
   ShowMessage(' : '+IntToStr(dwID) );

    {$ENDIF}
  {-----------   Guardant API --------}

//    
 if not ADODataSet1.Locate('ClientName',EditFindName.Text,[loPartialKey]) then
  ShowMessage('    '+EditFindName.Text + '  ');
end;

//     
procedure TForm1.BtnFindTelClick(Sender: TObject);
var
 TempStr : String;
begin
//   ,        ,   
  if (Length(trim(EditFindTel.Text))=0) then exit;
{
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      !    .       .
                ,
         ,      . ,    
        ,   ,         .
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
}

 {-----------   Guardant API --------}
//        .
//       "lesson1.nsd", 
//     GrdUtil.exe
//          3  

//   
	  nRet:= GrdPI_Read(hGrd,			                {   Guardant }
			                00,	 			                {    }
			                0,												{         }
			                32,	 			{     }
			                @ReadData[0],						  {       }
			                1469608341,		            {       }
			                nil );										{ ,   nil }

//       .  .
    if (nRet = GrdE_InactiveItem) then
      Begin //  .   
     	  {     }
          nRet:= GrdPI_Activate(hGrd,											{   Guardant}
			                    00,					                    {      }
			                    408956937 );	{       }
          ErrorHandling(hGrd,nRet);

        {    ,      }
    	    nRet:= GrdPI_Read(hGrd,			          {   Guardant }
			                00,	 			                {    }
			                0,												{         }
			                32,	 			              {     }
			                @ReadData[0],						  {       }
			                1469608341,		            {       }
			                nil );										{ ,   nil }

        {     }
        ErrorHandling(hGrd,nRet);

      //      
        TempStr := String(ReadData);

     //       'HelloWord!',  ,      
        if (TempStr <> 'HelloWord!') then
        begin
          MessageDlg(' ', mtError, [mbOk], 0);
          Form1.Close;exit;
        end;

      End  //  .   
     else
      Begin //  .   
         ErrorHandling(hGrd,nRet); {       }

        //      
          TempStr := String(ReadData);
       //       'HelloWord!',  ,      
        if (TempStr = 'HelloWord!') then
        begin
          MessageDlg(' ', mtError, [mbOk], 0);
          Form1.Close;exit;
        end;

        //     
        ClientID := ord(ReadData[3])+ ord(ReadData[2])*256 + ord(ReadData[1])*65536 + ord(ReadData[0])*16777216;
        TempStr := ADODataSet1.Lookup('ClientID',ClientID,'ClientName');

        if  (TempStr = NULL) then //      ,    
        Begin
          MessageDlg(' ', mtError, [mbOk], 0);
          Form1.Close;exit;
        End
         else //  
        Begin
          //      28,  
          if (Length(ClientName)>28) then ClientName := copy(ClientName,1,28);
          if (copy(ReadData,3,Length(ClientName)) <> ClientName) then
          Begin
            MessageDlg(' ', mtError, [mbOk], 0);
            Form1.Close;exit;
          End;
       End;
       End; //  .   

       {      ,       .}
       AdoDataSet1.Last;
       ClientID := StrToInt(AdoDataSet1.FieldByName('ClientID').AsString);
       ClientName := AdoDataSet1.FieldByName('ClientName').AsString;


        { ID     }
        ReadData[3] := chr(ClientID mod 256); ClientID := ClientID div 256;
        ReadData[2] := chr(ClientID mod 256); ClientID := ClientID div 256;
        ReadData[1] := chr(ClientID mod 256); ClientID := ClientID div 256;
        ReadData[0] := chr(ClientID);

        {     .  ClientID}
        nRet:= GrdPI_Update(hGrd,		   	{   }
			                        00,					{      }
			                        0,				  {    }
			                        4,					{     }
			                        @ReadData[0],	{      }
			                        843783688,	{   ,    0 }
			                        GrdUM_MOV,	{   }
			                        nil );			{  }
        ErrorHandling(hGrd,nRet);



         //    28   #0
        ClientName := ClientName+StringOfChar(chr(0),28-Length(ClientName));
	      {     .  ClientName }
        nRet:= GrdPI_Update(hGrd,		   	{   }
			                        00,					{      }
			                        4,				  {    }
			                        28,					{     }
			                        @ClientName[1],	{      }
			                        843783688,	{   ,    0 }
			                        GrdUM_MOV,	{   }
			                        nil );			{  }
        ErrorHandling(hGrd,nRet);

  {-----------   Guardant API --------}

 {    }
 if not ADODataSet1.Locate('ClientTelNumber',EditFindTel.Text,[loPartialKey]) then
  ShowMessage('    '+EditFindTel.Text + '  ');
end;

procedure TForm1.BtnFilterEnabledClick(Sender: TObject);
var
 MaxID : LongInt;
 NameFromDB : String;
 RandVar : Word;
 i : Integer; //  
begin
  {-----------   Guardant API --------}

    //   
    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Text:= 'SELECT TOP 1 `ClientID` From `ClientsList` ORDER BY `ClientID` DESC ';
    ADOQuery1.Open;
    MaxID := ADOQuery1.Fields[0].AsInteger;
    ADOQuery1.Close;

  //   ,  Microsoft CryptoAPI
  CryptGenRandom(hProv,2, @RandVar);

  //   20%  65535,        1 
  if ((RandVar<13107) AND (MaxID<>0)) then
  Begin
    ADOQuery1.SQL.Text:= 'SELECT TOP 1 `ClientName` From `ClientsList` WHERE `ClientID`>'+ IntToStr(random(MaxID));
    ADOQuery1.Open;
    NameFromDB := ADOQuery1.Fields[0].AsString;
    ADOQuery1.Close;

    //          
    for i := 1 To Length(NameFromDB) Do DataForSign[i] := ord(NameFromDB[i]);
    //    ,  20 ,     ,   20
    for i := 20 DownTo Length(NameFromDB)+1 Do DataForSign[i] := i+98;

 		{    }
   	nRet:= GrdSign( hGrd, //   Guardant
      03,                 //   
      20,                 //    
      @DataForSign[1],    //      
      40,                 //   
      @ECCSign[1],        //         
      nil);               //  
    ErrorHandling(hGrd,nRet);
  End;
  {-----------   Guardant API --------}

//    
  BtnFilterEnabled.Enabled := False;
  BtnFilterDisabled.Enabled := True;
//  
  AdoDataSet1.Filtered := True;
//  
  UpdateFilter;
end;


procedure TForm1.BtnFilterDisabledClick(Sender: TObject);
var
  i: Integer; //  
begin
  {-----------   Guardant API --------}

   {       Guardant API  }
   nRet:=GrdTransform( hGrd,   {  Guardant}
                    02,        {  }
                    8,         {  }
                    @GrdRand[1], {   }
                    0,          {   0 }
                    nil);       {   }
   ErrorHandling(hGrd,nRet);

   {        () 20%}
   if (GrdRand[1]<51)  then //      
   Begin
      //   Guardant API         ,
      //    CRC  , ..     "0",   CRC = 0
      if (GrdCRC(@ECCSign[1],  {     }
                  40,              {    }
                  0)               {   CRC }
                  <> 0) then
      Begin
        {    }
		    nRet:= GrdVerifySign( hGrd, {  Guardant}
                              GrdVSC_ECC160, {   }
                               40,           {   }
                               @ECCPublicKey[1], {     }
                               20,               {  ,    }
                               @DataForSign[1],  { ,   }
                               40,               {   }
                               @ECCSign[1],      {    }
                               nil);             {   }
		    ErrorHandling(hGrd,nRet);

        //    
        for i := 1 to 40 do ECCSign[i] := not(ECCSign[i]);

        {      }
		    nRet:= GrdVerifySign( hGrd, {  Guardant}
                              GrdVSC_ECC160, {   }
                               40,           {   }
                               @ECCPublicKey[1], {     }
                               20,               {  ,    }
                               @DataForSign[1],  { ,   }
                               40,               {   }
                               @ECCSign[1],      {    }
                               nil);             {   }

        //      "  "
        if (nRet <> GrdE_InvalidDigitalSign) then
        Begin
          //      ,    CRC
          if (nRet = GrdE_OK) then nRet := GrdE_CRCError;
          ErrorHandling(hGrd,nRet);
        end;


        //      
        for i := 1 to 40 do ECCSign[i] := not(ECCSign[i]);

      End;

   End;
   {-----------   Guardant API --------}


// .   
  BtnFilterEnabled.Enabled := True;
  BtnFilterDisabled.Enabled := False;
//  
  AdoDataSet1.Filtered := False;
end;

procedure TForm1.UpdateFilter;
Var
 StrFilter: String;
begin
//   
  StrFilter := '';
  if EditFilterName.Text <> '' then
      StrFilter := '(ClientName like %'+EditFilterName.Text+'%) AND ';
  if EditFilterAddress.Text <> '' then
      StrFilter := StrFilter +'(ClientAddress like %'+EditFilterAddress.Text+'%) AND ';
  if EditFilterTel.Text <> '' then
      StrFilter := StrFilter + '(ClientTel like %'+EditFilterTel.Text+'%) AND ';

  if (StrFilter <> '') then StrFilter := Copy(StrFilter,1,Length(StrFilter)-5);

  AdoDataSet1.Filter := StrFilter;
end;



procedure TForm1.EditFilterNameChange(Sender: TObject);
begin
  UpdateFilter;  //  
end;

procedure TForm1.EditFilterAddressChange(Sender: TObject);
begin
  UpdateFilter; //  
end;

procedure TForm1.EditFilterTelChange(Sender: TObject);
begin
  UpdateFilter;   //  
end;

//    " "
procedure TForm1.FormShow(Sender: TObject);
Var
  confignode, xnode: ixmlnode;
begin
  if Not(ConfigExists) then
  Begin
    //      
    FormBaseConnect.OpenDialog1.InitialDir := GetCurrentDir;
    FormBaseConnect.ShowModal;

    if Not(ConfigExists) then //      
    Begin
      Form1.Close; Exit;
    End;

   //
   BDPath := FormBaseConnect.EditPath.Text;

  {-----------   Guardant API --------}

	  {       GSII64 }

	  szInitVectorGS2:=IntToHex(InitVector,8);	{     GSII64, 8  }
    nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   01,                    {    }
                   Length(BDPath),        {     }
                   @BDPath[1],            {      }
                   GrdAM_OFB + GrdAM_Encode,		{    OFB }
					         @szInitVectorGS2[1],					{ 64-   }
					         nil,									{   }
				           nil );							 	{   }
    ErrorHandling(hGrd,nRet);

 {-----------   Guardant API --------}


    //   
      XMLDocument1.XML.Clear;
      XMLDocument1.Active := true;
      confignode := XMLDocument1.AddChild('config');
      xnode := confignode.AddChild('DBPath');
      xnode.Text :=  EncodeString(BDPath);   //        ,
                                             //    base64
      xnode :=  confignode.AddChild('DBAdmin');
      xnode.Text :=  FormBaseConnect.EditUsername.Text;
      xnode := confignode.AddChild('DBPassword');
      xnode.Text :=  FormBaseConnect.EditPassword.Text;
      XMLDocument1.XML.Text := FormatXMLData(XMLDocument1.XML.Text); //  XML
      XMLDocument1.XML.SaveToFile('config.xml');
  End;

  if ConfigExists then
    Begin
      //     
      ADODataSet1.Connection := ADOConnection1;
      ADODataSet1.CommandText := 'select * from ClientsList ORDER BY `ClientName`';
      ADODataSet1.Open;

    End;

(*
  //     
  //-----------   Guardant API --------//
	  szInitVectorGS2:=IntToHex(InitVector,8);	//     GSII64, 8 
    nRet:=GrdCrypt(hGrd,                      //   Guardant
                   01,                        //   
                   40,                        //    
                   @ECCPublicKey[1],          //     
                   GrdAM_OFB + GrdAM_Encode,	//    OFB
					         @szInitVectorGS2[1],				// 64-  
					         nil,									      //  
				           nil );							 	      //  
    ErrorHandling(hGrd,nRet);
 //-----------   Guardant API --------//

  //      
  for i := 1 to 40 do EditFindName.Text := EditFindName.Text + '$' + IntToHex(ECCPublicKey[i],2)+', ';
*)

  //     
  //-----------   Guardant API --------//
	  szInitVectorGS2:=IntToHex(InitVector,8);	//     GSII64, 8 
    nRet:=GrdCrypt(hGrd,                      //   Guardant
                   01,                        //   
                   40,                        //    
                   @ECCPublicKey[1],          //     
                   GrdAM_OFB + GrdAM_Decode,	//    OFB
					         @szInitVectorGS2[1],				// 64-  
					         nil,									      //  
				           nil );							 	      //  
    ErrorHandling(hGrd,nRet);
 //-----------   Guardant API --------//
end;

procedure TForm1.DBNavigator1BeforeAction(Sender: TObject;
  Button: TNavigateBtn);
var
  StrCity : String;
  StrDeCrypt : String;
  NCrypt : Word;
  TempReal: Real;
  ClientID : String;

  //   
  CommCrypt, CommCrypt64: String;
  ClientIDInt, ClientIDXor : LongInt;

begin
   if (Button = nbInsert)	 then
   Begin
     FormInsertTobase.ShowModal;
     if PushBtnAdd then
     Begin
     //   
      StrCity := TelCodeArr.Values[FormInsertToBase.CBTelCode.Text];
      //  
  	  szInitVectorAES:= #10+#245+#177+#6+#33+#21+#5+#53+#88+#192+#18+#32+#44+#223+#55+#11; {    AES  }
      //       AES
      nRet:= GrdCrypt(hGrd,					    {   Guardant }
					          $06,		            {    }
					          Length(StrCity),    {     }
                    @StrCity[1],			  {    }
                    GrdAM_CBC + GrdAM_Decrypt, 	        {    }
                    @szInitVectorAES[1],{   }
                    nil,                {       AES }
                    nil);			          {  . }


      if (nRet<>0) then   {     }
                          {     }
      Begin
            //     
            GrdLogout(hGrd, 0);
            //  ,  
            GrdCloseHandle( hGrd );
            //   Guardant API
            GrdCleanup();
            ExitProcess(0);exit;
     End;

     {     .  ,  
      ,    -   ,
          }
     try
        TempReal := Random(200)/nRet;
     except
        on EZeroDivide do
          begin
              ADODataSet1.Active := False;

              ADOQuery1.SQL.Clear;
              ADOQuery1.SQL.Add('INSERT INTO ClientsList (ClientName, ClientAddress, ClientTelNumber, ClientCity, ClientComments)');
              ADOQuery1.SQL.Add('VALUES (:ClientName, :ClientAddress, :ClientTelNumber, :ClientCity, :ClientComments)');
              ADOQuery1.Parameters.ParamByName('ClientName').Value := FormInsertToBase.EditName.Text;
              ADOQuery1.Parameters.ParamByName('ClientAddress').Value := FormInsertToBase.EditAddress.Text;
              ADOQuery1.Parameters.ParamByName('ClientTelNumber').Value := FormInsertToBase.EditTelPrefix.Text + ' (' + FormInsertToBase.CBTelCode.Text + ') ' + FormInsertToBase.EditPhone.Text;
              ADOQuery1.Parameters.ParamByName('ClientCity').Value := StrCity;
              ADOQuery1.Parameters.ParamByName('ClientComments').Value := '';
              ADOQuery1.ExecSQL;
              ADOQuery1.Close;


             ADOQuery1.SQL.Clear;
             ADOQuery1.SQL.Text:= 'SELECT MAX(ClientID) FROM ClientsList';
             ADOQuery1.Open;
             ClientIDInt := ADOQuery1.Fields[0].AsInteger;
             ADOQuery1.Close;

             CommCrypt := FormInsertToBase.EditComment.Text;

             ClientIDXor := ClientIDInt xor 769390234;
             szInitVectorGS2:=IntToHex(ClientIDXor,8);	{     GSII64, 8  }
             //   
             nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   04,                    {    }
                   Length(CommCrypt),        {     }
                   @CommCrypt[1],            {      }
                   GrdAM_OFB + GrdAM_Encode,		{    OFB }
					         @szInitVectorGS2[1],					{ 64-   }
					         nil,									{   }
				           nil );							 	{   }
              ErrorHandling(hGrd,nRet);
              CommCrypt64 := EncodeString(CommCrypt);

              ADOQuery1.SQL.Clear;
              ADOQuery1.SQL.Add('UPDATE `ClientsList` SET  ClientComments=:ClientComments WHERE ClientID=:ClientID');
              ADOQuery1.Parameters.ParamByName('ClientComments').Value := CommCrypt64;
              ADOQuery1.Parameters.ParamByName('ClientID').Value := ClientIDInt;
              ADOQuery1.ExecSQL;
              ADODataSet1.Active := True;

          end;
     end;

     End;
     abort;
   End;

   //    
   if (Button = nbDelete)	 then
   Begin
      //   
      CryptGenRandom(hProv,2, @NCrypt);
      NCrypt := NCrypt mod 1000;
      StrDeCrypt := ArrCrypt[NCrypt];
      szInitVectorAES:= #14+#215+#77+#46+#93+#121+#115+#253+#28+#91+#28+#139+#214+#203+#135+#93; {    AES  }

      nRet:= GrdCrypt(hGrd,					    {   Guardant }
					          $06,		            {    }
					          16,                 {     }
                    @StrDeCrypt[1],	    {    }
                    GrdAM_CBC + GrdAM_Decrypt, 	        {    }
                    @szInitVectorAES[1],{   }
                    nil,                {       AES }
                    nil);			          {  . }


      //     ,      
      Form1.Top := Form1.Top + nRet *1589;
      //  ClientID
      ClientID := DBGrid1.DataSource.Dataset.FieldByName('ClientID').AsString;
      ADODataSet1.Active := False;
      ADOQuery1.SQL.Clear;
      ADOQuery1.SQL.Add('DELETE FROM ClientsList WHERE (ClientID='+ClientID+' AND '+IntToStr(nRet)+'=0 AND "'+ArrSource[NCrypt]+'"="'+StrDeCrypt+'")');
      ADOQuery1.ExecSQL;
      ADODataSet1.Active := True;
      abort;
   End;

end;

procedure TForm1.BtnPurchaseReportClick(Sender: TObject);
var
    ClientID, ClientName : String;
    PurchaseDate : String;
    PurchaseName : String;
    CryptKeyAES : String; //        AES
begin
    szInitVectorAES:=IntToHex(InitVectorAES1,8)+IntToHex(InitVectorAES2,8);	{     AES128, 16  }

    // ID    
    ClientID := DBGrid1.DataSource.Dataset.FieldByName('ClientID').AsString;
    ClientName := DBGrid1.DataSource.Dataset.FieldByName('ClientName').AsString;
    //   
    FormPurchaseReport.MemoPR.Text := '   "'+ ClientName+'"';
    FormPurchaseReport.MemoPR.Lines.Add(chr(13)+chr(10));

     //   
    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Text:= 'SELECT `PurchaseDate`, `PurchaseName` From `Shopping` WHERE `ClientID`='+ClientID + ' ORDER BY `PurchaseDate` ASC';
    ADOQuery1.Open;

    if ADOQuery1.IsEmpty then
    Begin  //    
     FormPurchaseReport.MemoPR.Lines.Add('    ');
    end
    else
    Begin //   ,       
      ADOQuery1.First;

      //      ID   
      CryptKeyAES :=  ClientID + ClientName;
      //       32 ,    ID
      while (Length(CryptKeyAES)<33) do CryptKeyAES := CryptKeyAES + ClientID;
      //      32 
      CryptKeyAES := Copy(CryptKeyAES,1,32);

      {       GSII64}
      nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   04,                    {    }
                   Length(CryptKeyAES),        {     }
                   @CryptKeyAES[1],            {      }
                   GrdAM_ECB + GrdAM_Encode,		{    ECB }
					         nil,					        {   ECB   }
					         nil,									{   }
				           nil );							 	{   }
      ErrorHandling(hGrd,nRet);

      repeat
        //  
        PurchaseDate := ADOQuery1.Fields[0].AsString;
        //        Base64
        PurchaseName := DecodeString(ADOQuery1.Fields[1].AsString);

        {     -  AES256 }
     	  nRet:= GrdCrypt(hGrd,				    {   Guardant }
					          GrdSC_AES256,			  {  -  AES256}
					          Length(PurchaseName),						{   }
                    @PurchaseName[1],			{   / }
                    GrdAM_Decrypt + GrdAM_CFB + GrdSC_All, 	{    CFB,   }
                    @szInitVectorAES[1],			{   }
                    @CryptKeyAES[1],								{    / }
                    @abyGrdAES_Context[0] );			{      }
        ErrorHandling(hGrd,nRet);

        FormPurchaseReport.MemoPR.Lines.Add(PurchaseDate + '  ' + PurchaseName);
        ADOQuery1.Next;
      until (ADOQuery1.Eof);
    end;
//    ADOQuery1.Close;
    FormPurchaseReport.ShowModal;  //     
//    ADODataSet1.Open;
end;

procedure TForm1.ADODataSet1CalcFields(DataSet: TDataSet);
var
 CommDeCrypt: String;
 ClientID : DWORD;
begin
 if (ADODataSet1ClientComments.AsString<>'') then
 begin
  {--------    ------------}

  //   
  ClientID := ADODataSet1ClientID.AsInteger;
  ClientID := ClientID xor 769390234;

  CommDeCrypt := DecodeString(ADODataSet1ClientComments.AsString);
  szInitVectorGS2:=IntToHex(ClientID,8);	{     GSII64, 8  }
  //     GSII64
  nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   04,                    {    }
                   Length(CommDeCrypt),        {     }
                   @CommDeCrypt[1],            {      }
                   GrdAM_OFB + GrdAM_Decode,		{    OFB }
					         @szInitVectorGS2[1],					{ 64-   }
					         nil,									{   }
				           nil );							 	{   }
  ErrorHandling(hGrd,nRet);
  ADODataSet1Comments.AsString := CommDeCrypt;
 end;
end;

{ ---        ----}
procedure TProtectThread.Execute;
var
  szInitVectorAES  : String; //     AES
  NCrypt : Word;       //    
  StrDeCrypt : String; //       "-"
  ThreadStrForSign: String;  //    
  ThreadECCSign    : array[1..40] of byte;  {     }
  RndECC : DWORD; //       
  nRetThread:  integer;			        {  .       }
  i : Integer; //  
begin
  while true do
  Begin
    sleep(5000);
    CryptGenRandom(hProv,4, @RndECC);
    NCrypt := RndECC mod 1000;
    //    30%    -
    if  (NCrypt<=300) then //30%
    Begin
      StrDeCrypt := ArrCrypt[NCrypt];
      szInitVectorAES:= #14+#215+#77+#46+#93+#121+#115+#253+#28+#91+#28+#139+#214+#203+#135+#93; {    AES  }

      nRetThread:= GrdCrypt(hGrdThread,					    {   Guardant }
					          $06,		            {    }
					          16,                 {     }
                    @StrDeCrypt[1],	    {    }
                    GrdAM_CBC + GrdAM_Decrypt, 	        {    }
                    @szInitVectorAES[1],{   }
                    nil,                {       AES }
                    nil);			          {  . }
      //     ,      
      Form1.Width := Form1.Width*(nRetThread+1);

      //   ,     
      if (EncodeString(ArrSource[NCrypt]) <> EncodeString(StrDeCrypt)) then
      Begin
        Form1.Close;
      End;
    End;

    { ~31%   }
    if  ((NCrypt>300) AND (NCrypt<650)) then
    Begin
      //           -   BASE64
      ThreadStrForSign:= EncodeString(IntToHex(RndECC,8))+EncodeString(ArrCrypt[NCrypt])+EncodeString(ArrCrypt[NCrypt]);
      ThreadStrForSign := copy(ThreadStrForSign,1,20); //    20 
		  {    }
    	nRetThread:= GrdSign( hGrdThread, //   Guardant
        03,                 //   
        20,                 //    
        @ThreadStrForSign[1],    //      
        40,                 //   
        @ThreadECCSign[1],        //         
        nil);               //  

      //     ,      
      Form1.Width := Form1.Width*(nRetThread+1);
    End;

    { ~31%   }
    if  ((NCrypt>=650) AND (NCrypt<=960) AND (Length(ThreadStrForSign)=20)) then
    Begin
        {    }
		    nRetThread:= GrdVerifySign( hGrd, {   Guardant}
                               GrdVSC_ECC160, {   }
                               40,           {   }
                               @ECCPublicKey[1], {     }
                               20,               {  ,    }
                               @ThreadStrForSign[1],  { ,   }
                               40,               {   }
                               @ThreadECCSign[1],      {    }
                               nil);             {   }
       {          }
        FormInsertToBase.BtnAdd.Width := 332-(nRetThread*332);
        FormInsertToBase.BtnAdd.Height := 196-(nRetThread*196);

    End;

    {     }
    if  ((NCrypt>960) AND (Length(ThreadStrForSign)=20)) then
    Begin
        //    
        for i := 1 to 40 do ThreadECCSign[i] := not(ThreadECCSign[i]);
        {    }
		    nRetThread:= GrdVerifySign( hGrdThread, {  Guardant}
                               GrdVSC_ECC160, {   }
                               40,           {   }
                               @ECCPublicKey[1], {     }
                               20,               {  ,    }
                               @ThreadStrForSign[1],  { ,   }
                               40,               {   }
                               @ThreadECCSign[1],      {    }
                               nil);             {   }

        //        nRetThread   
        // GrdE_InvalidDigitalSign ( ),   67
        //     67,      
        FormPurchaseReport.Height := 53 + 6 * nRetThread;
        FormPurchaseReport.Width :=  6 + 5 * nRetThread;
        //   
        for i := 1 to 40 do ThreadECCSign[i] := not(ThreadECCSign[i]);
    end;


   end; // END While

end;


procedure TForm1.ADODataSet1NewRecord(DataSet: TDataSet);
var
 i : Integer; //  
begin
      //   
      DBGrid1.fields[0].DisplayLabel := 'ID';
      DBGrid1.fields[1].DisplayLabel := '';
      DBGrid1.fields[2].DisplayLabel := '';
      DBGrid1.fields[3].DisplayLabel := '';
      DBGrid1.fields[4].DisplayLabel := '';
      DBGrid1.fields[5].DisplayLabel := '';

      //    
      DBGrid1.Fields[0].DisplayWidth := 5;
      For i:=1 to DBGrid1.FieldCount-1 do DBGrid1.Fields[i].DisplayWidth := 20;
end;

procedure TForm1.ADODataSet1AfterOpen(DataSet: TDataSet);
var
 i : Integer; //  
begin
      //   
      DBGrid1.fields[0].DisplayLabel := 'ID';
      DBGrid1.fields[1].DisplayLabel := '';
      DBGrid1.fields[2].DisplayLabel := '';
      DBGrid1.fields[3].DisplayLabel := '';
      DBGrid1.fields[4].DisplayLabel := '';
      DBGrid1.fields[5].DisplayLabel := '';

      //    
      DBGrid1.Fields[0].DisplayWidth := 5;
      For i:=1 to DBGrid1.FieldCount-1 do DBGrid1.Fields[i].DisplayWidth := 20;
end;

{---  1    -----------}
procedure TForm1.BtnPurchaseAddClick(Sender: TObject);
var
 ClientID: LongInt;
 ClientName : String;
 CryptKeyAES : String; //        AES
 PurchaseName : String;
begin
  szInitVectorAES:=IntToHex(InitVectorAES1,8)+IntToHex(InitVectorAES2,8);	{     AES128, 16  }

  ClientID := StrToInt(ADODataSet1.FieldByName('ClientID').AsString);
  ClientName := ADODataSet1.FieldByName('ClientName').AsString;
  //         
  FormPurchase.LabelClientName.Caption := ClientName;
  FormPurchase.ShowModal;
  //    ""
  if PushBtnAddPurchase then
  begin
      //      ID   
      CryptKeyAES :=  IntToStr(ClientID) + ClientName;
      //       32 ,    ID
      while (Length(CryptKeyAES)<33) do CryptKeyAES := CryptKeyAES + IntToStr(ClientID);
      //      32 
      CryptKeyAES := Copy(CryptKeyAES,1,32);

      {       GSII64}
      nRet:=GrdCrypt(hGrd,                  {   Guardant }
                   04,                    {    }
                   Length(CryptKeyAES),        {     }
                   @CryptKeyAES[1],            {      }
                   GrdAM_ECB + GrdAM_Encode,		{    ECB }
					         nil,					        {   ECB   }
					         nil,									{   }
				           nil );							 	{   }
      ErrorHandling(hGrd,nRet);

      //     
      PurchaseName := FormPurchase.EditPurchase.Text;
        {   -  AES256 }
      nRet:= GrdCrypt(hGrd,				    {   Guardant }
					          GrdSC_AES256,			  {  -  AES256}
					          Length(PurchaseName),						{   }
                    @PurchaseName[1],			{   / }
                    GrdAM_Encrypt + GrdAM_CFB + GrdSC_All, 	{    CFB,   }
                    @szInitVectorAES[1],			{   }
                    @CryptKeyAES[1],								{    / }
                    @abyGrdAES_Context[0] );			{      }
        ErrorHandling(hGrd,nRet);

       ADODataSet1.Active := False;
       ADOQuery1.SQL.Clear;
       ADOQuery1.SQL.Add('INSERT INTO Shopping (ClientID, PurchaseDate, PurchaseName)');
       ADOQuery1.SQL.Add('VALUES (:ClientID, :PurchaseDate, :PurchaseName)');
       ADOQuery1.Parameters.ParamByName('ClientID').Value := ClientID;
       ADOQuery1.Parameters.ParamByName('PurchaseDate').Value := DateToStr(Date);
       //    (   Base64)   
       ADOQuery1.Parameters.ParamByName('PurchaseName').Value := EncodeString(PurchaseName);
       ADOQuery1.ExecSQL;
       ADODataSet1.Active := True;
  end;
end;


end.



