{------------------------------------------------------------------------------}
{             1000                     }
{           AES,                   }
{          Guardant                                                      }
{------------------------------------------------------------------------------}

program GenerateAES1000;

{$APPTYPE CONSOLE}

  uses
    SysUtils, Dialogs,
    GRDDelphi;

{----------------------------------------------------------------------------------------------}
{     Guardant API                                                       }

{ :    Guardant                                                             }
{	:                                                                              }
{--------------------------------------------------------------------------------------------- }
procedure ErrorHandling(hGrd:HANDLE;nRet:integer);
var
 ErrorMsg: Array[1..5000] of Char;
 PErrorMsg: PChar;
begin
  	  if( nRet <> GrdE_OK ) Then //   
	      begin
            //      Guardant     (      )
           GrdFormatMessage(hGrd,nRet,GrdLng_ENG,@ErrorMsg[1],5000,nil );
           PErrorMsg := @ErrorMsg;
           WriteLn(String(PErrorMsg));

           	if( hGrd <> nil )	Then //   ,      Guardant API
            begin
              //     
              GrdLogout(hGrd, 0);
              //  ,  
              GrdCloseHandle( hGrd );
            end;
            //   Guardant API
            GrdCleanup();
            writeln('Press Enter to exit');
            readln;
            halt(0);
	      end;

end;

//   
function PADR(Src: string; Lg: Integer): string;
begin
  Result := Src;
  while Length(Result) < Lg do
    Result := Result + ' ';
end;

  {  }
  const CryptPU:      DWORD=$8566783;							  {       }
        CryptRD:      DWORD=$17d49c84;							{       }
        CryptWR:      DWORD=$9843de24;							{       }
        CryptMS:      DWORD=$47832845;							{       }

{  }
  var 	dwPublic:     DWORD;				{    }
       	dwPrivRD:     DWORD;				{    }
//       	dwPrivWR:     DWORD;				{    }
//      	dwPrivMS:     DWORD;				{    }

        dwRemoteMode:         DWORD;					      {    }
        dwFlags:              DWORD;							  {   }
        byProg:               Byte;								  {   }
        byVer:                Byte;									{  }
        dwID:                 DWORD;								{   (ID) }
        wSN:                  Word;									{   }
        wMask:                Word;						      {   }
        wType:                Word;						      {   }
        dwModel:              DWORD;				        {   }
        dwInterface:          DWORD;			          {    }
        nRet:                 integer;			        {   }
        i, i1000:             integer;
        szInitVectorAES:      string;               {    AES }
        hGrd:HANDLE;                                {   Guardant }

        //     -
        FileResult : TextFile;
        TempStr : String;
        TmpArr : Array[1..16] of byte;
{------------------------- main block -----------------------------------------}
  begin

  randomize; //    

//  Guardant API
  nRet := GrdStartupEx(GrdFMR_Local, nil, nil);
  ErrorHandling(nil,nRet); {    }

//    Guardant API
  hGrd := GrdCreateHandle(nil, GrdCHM_MultiThread,  nil );
  ErrorHandling(hGrd,nRet);

  //      
  dwPublic:= GrdDC_DEMONVK-CryptPU;				{      }
  dwPrivRD:= GrdDC_DEMORDO-CryptRD;				{      }

  //      (   )
  nRet:= GrdSetAccessCodes(hGrd,   dwPublic + CryptPU,  dwPrivRD + CryptRD, 0, 0 );
  ErrorHandling(hGrd,nRet);

//    
    dwRemoteMode:= GrdFMR_Local;	{    }
    dwFlags:= GrdFM_nProg+GrdFM_Mask;     	    {       }
    dwID:=   0;                   {      }
    byProg:= 5; 	                {    ,      }
    wSN:=    0;	                  {       }
    byVer:=  0;                   {      }
    wMask:=  77;                  {    }
    wType:=  0;                   {      }
    dwModel:= GrdFMM_ALL;         {   }
    dwInterface:= GrdFMI_ALL;     {    }
    nRet := GrdSetFindMode(hGrd,  dwRemoteMode, dwFlags, byProg, dwID, wSN, byVer, wMask, wType, dwModel, dwInterface );
    ErrorHandling(hGrd,nRet);

    //     (    GrdFindMode).
    //     Guardant API,    GrdCloseHandle()/GrdLogin()    
    nRet:= GrdLogin(hGrd,  $0FFFFFFFF, GrdLM_PerStation );
    ErrorHandling(hGrd,nRet);


	  {     }
    nRet := GrdPI_Activate(hGrd,				{   Guardant}
		                    05,					  {      }
		                    875679933 );	{       }
    ErrorHandling(hGrd,nRet);

	  {   }
	  writeln('Generate table by AES algo: ');

    {  ,    }
    AssignFile(FileResult,'result1000_arr.txt');
    ReWrite(FileResult);

    i1000 := 0;
    while (i1000<1000) Do
    Begin
       //      
       For i := 1 To 16 Do TmpArr[i] := Random(26)+65;

      //    AES 
  	   szInitVectorAES:= #14+#215+#77+#46+#93+#121+#115+#253+#28+#91+#28+#139+#214+#203+#135+#93;

      //         Delphi
      TempStr := 'ArrSource['+IntToStr(i1000)+'] := ';
      for i := 1 To 15 Do
            TempStr := TempStr +'#' + IntToStr(TmpArr[i])+ '+';

            TempStr := TempStr +'#' + IntToStr(TmpArr[16])+';';
      writeln(FileResult, TempStr);

      {       AES }

	    nRet:= GrdCrypt(hGrd,					  {   Guardant }
					          05,			          {    }
					          16,               {     }
                    @TmpArr[1],			    {    }
                    GrdAM_CBC + GrdAM_Encrypt, 	        {    }
                    @szInitVectorAES[1],{   }
                    nil,                {       AES }
                    nil);			          {  . }
      ErrorHandling(hGrd,nRet);

      {         Delphi}
      TempStr := 'ArrCrypt['+IntToStr(i1000)+'] := ';
      for i := 1 To 15 Do
            TempStr := TempStr +'#' + IntToStr(TmpArr[i])+ '+';

            TempStr := TempStr +'#' + IntToStr(TmpArr[16])+';';
      writeln(FileResult, TempStr);

      inc(i1000);
    end;

    { }
    CloseFile(FileResult);


	  {    ,      }
    nRet := GrdPI_Deactivate(hGrd,				{   Guardant}
		                    05,					  {      }
		                    136056856 );	{       }
     ErrorHandling(nil,nRet);

	  {   hGrd }
    nRet:=GrdCloseHandle( hGrd );
    ErrorHandling(nil,nRet);

	  {   GrdAPI.  }
	  nRet:= GrdCleanup();
	  ErrorHandling(nil,nRet);

    writeln('All done. Press Enter to exit');
    readln;
end.
